/*************************************************************************
   O R T E P   M A I N   R O U T I N E  for  S U N  O P E N  W I N D O W S
   Aug 9, 1991   N.Y.
   Graphics routines call Xview and Xlib
   Aug 12 1991	PostScript file output supported.
   Aug 16 1991	Drag and Move Symbols supported.
   Sep 18 1991	Header of PS-file is changed a little.
   Sep 27 1991  Header of PS-file is changed a little, adding user name.
   Oct 30 1991  Icon Image added.
   Nov  1 1991  draw_char_rect() is changed.
   Jan	7 1992  Print button  added.
   Jan 2001 MK  Ortep-III adapted for use with this program 
                Font handling simplified to get rid of the huge memory leaks

	One unit of distances is 1/72 inches.
**************************************************************************/

#include <stdio.h>
#include <strings.h>
#include <time.h>
#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/xv_xrect.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/font.h>
#include <xview/textsw.h>
#include <xview/icon.h> 

/*
static short edit_ic_image[256]={
#include <ortep_im.icon>
}; 

static short edit_mask_image[256]={
#include <ortep_im_mask.icon>
}; 
*/


#define	kWIN_WIDTH		650  /* dots of window size	*/
#define	kWIN_HEIGHT		550  /* dots of window size	*/
#define kPANEL_TEXT_HEIGHT	32   /* dots of panel height	*/
#define kPANEL_TEXT_LEN		24   /* characters of panel text*/
#define kMAX_LINES		64000 /* maximum num. of line objects*/
#define kMAX_SYMBOLS		2000 /* maximum num. of symbol objects*/
#define kTEXTSW_WIN_HEIGHT	240	/* text sub window */

#define kChoice_NOP		0
#define kChoice_LINE		1
#define kChoice_DASH		2
#define kChoice_TEXT		3

typedef struct {
		float		fx,fy;
		float		fhgt;		/* symbol height(points) */
		char		fname[72];
		float		ftheta;		/* rotation angle	*/
		int		fnum;		/* number of characters */
		} aSymbol;

typedef struct {
		float		fx,fy;
		int		id;
		} aLine;

typedef struct {
		int		dx;
		int		dy;
		} aOffset;

typedef struct {
		int		width;
		int		height;
		} aRect;


/*****	Function declarations	*****/
void	about_proc();
void	open_proc();
void	draw_proc();
void	quit_proc();
void	ps_save_proc();
void	save_ps_file();
void	print_proc();
void	my_repaint_proc();
void	help_proc();
Panel_setting	text_proc();
int	file_exist();
void	event_proc();
void	plot_display();
void	draw_char_rect();
void	change_sym_loc();
aSymbol	*whichSymPointed();
aRect	get_sym_rect();
aOffset	get_offset();
void	clear_sym_area();
void	text_noti_proc();
void	choice_noti_proc();
extern void ortepmain_();	/* ORTEP MAIN FORTRAN PROGRAM */
void plot_();
void symbol_();
void number_();
void gpsltm_();
void ginit_();
void vsini_();
void device_();
void rwind_();
void charac_();
void newpen_();
void vsterm_();
void tinput_();
void pinit_();

/*****	Global Variables	*****/
GC		gGC;
GC		gGCXOR;
Frame		gFrame;
Canvas		gCanvas;
Display		*gDPY;
XID		gXID;
Panel_item	gPanel_text;
aLine		gLines[kMAX_LINES];
aSymbol		gSymbol[kMAX_SYMBOLS];
int		gNumSymbol=0;	/* number of symbols & lines plotted */
int		gNumLine=0;
Textsw		gTextsw;
int		gCanvas_choice = 0;
float		gPensize = 0.5;	/* pen width for plotting	*/
float		gXorigin = 0.0;
float		gYorigin = 0.0;

/****************************************/
/* a beginning of beautiful friendship.	*/
/****************************************/
int
main(argc,argv)
int	argc;
char *argv[];
{
	Panel		panel;
/*	Panel		panel2; */
	Icon		ortep_icon;
	Server_image	icon_image;
	Server_image	mask_image;

	xv_init(XV_INIT_ARGC_PTR_ARGV,&argc,argv,NULL);

/******	Making of Icon Image			*/
/*
     	icon_image = xv_create(0, SERVER_IMAGE,
                SERVER_IMAGE_BITS, edit_ic_image,
                SERVER_IMAGE_DEPTH, 1,
                XV_WIDTH, 64,
                XV_HEIGHT, 64,
                0);

     	mask_image = xv_create(0, SERVER_IMAGE,
                SERVER_IMAGE_BITS, edit_mask_image,
                SERVER_IMAGE_DEPTH, 1,
                XV_WIDTH, 64,
                XV_HEIGHT, 64,
                0);

        ortep_icon= xv_create(0, ICON,
                        ICON_IMAGE, icon_image,
			ICON_MASK_IMAGE, mask_image,
			ICON_TRANSPARENT, TRUE,
                        0);

	xv_set(ortep_icon,
		WIN_CONSUME_EVENTS,
		LOC_WINENTER,
		LOC_WINEXIT,
		LOC_DRAG,
		0,
		0);
*/

/******  Making of Frame, Panel	************************************/
	gFrame = (Frame)xv_create (0,FRAME,
				FRAME_LABEL,	"Ortep",
	    		/*	FRAME_ICON,	ortep_icon, */
				NULL);

	panel = (Panel)xv_create (gFrame,PANEL,
				XV_X, 0 , XV_Y, 0,
				XV_WIDTH,	kWIN_WIDTH,
				XV_HEIGHT,	kPANEL_TEXT_HEIGHT,
        			PANEL_LAYOUT,	PANEL_HORIZONTAL,
				NULL);
/***** Making of Buttons *******************************************/
	(void)xv_create(panel,PANEL_BUTTON,
				PANEL_LABEL_STRING,"About",
				PANEL_NOTIFY_PROC, about_proc,
				NULL);

/* "Open" button was deleted --- Oct. 31, 1991 ---
	(void)xv_create(panel,PANEL_BUTTON,
				PANEL_LABEL_STRING,"Open",
				PANEL_NOTIFY_PROC, open_proc,
				NULL);
*/
	gPanel_text = (Panel_item)xv_create(panel,PANEL_TEXT,
				PANEL_LABEL_STRING," File : ",
				PANEL_VALUE,argv[1],
				PANEL_NOTIFY_LEVEL, PANEL_SPECIFIED,
				PANEL_NOTIFY_PROC,text_proc,
				PANEL_VALUE_DISPLAY_LENGTH, kPANEL_TEXT_LEN,
				NULL);

	(void)xv_create(panel,PANEL_BUTTON,
				PANEL_LABEL_STRING,"Draw(Save)",
				PANEL_NOTIFY_PROC, draw_proc,
				NULL);

	(void)xv_create(panel,PANEL_BUTTON,
				PANEL_LABEL_STRING, "PS-Save",
				PANEL_NOTIFY_PROC, ps_save_proc,
				NULL);
/*
	(void)xv_create(panel,PANEL_BUTTON,
				PANEL_LABEL_STRING, "Help",
				PANEL_NOTIFY_PROC, help_proc,
				NULL);
*/
	(void)xv_create(panel,PANEL_BUTTON,
				PANEL_LABEL_STRING, "Print",
				PANEL_NOTIFY_PROC, print_proc,
				NULL);

	(void)xv_create(panel,PANEL_BUTTON,
				PANEL_LABEL_STRING, "Quit",
				PANEL_NOTIFY_PROC, quit_proc, 
				NULL);

/*****  Making of Text Sub Window *********************************/
	gTextsw = (Textsw)xv_create(gFrame,TEXTSW,
				XV_X, 0,
				WIN_BELOW, panel,
				XV_WIDTH,kWIN_WIDTH,
				XV_HEIGHT,kTEXTSW_WIN_HEIGHT,
				TEXTSW_FILE,argv[1],
				NULL);
	xv_set(gTextsw,TEXTSW_NOTIFY_PROC,text_noti_proc,NULL);

/*****  Making of Choice item   **********************************/
/*
	panel2 = (Panel)xv_create (gFrame,PANEL,
				XV_X, 0,
				XV_HEIGHT, 32,
				WIN_BELOW, gTextsw,
				NULL);

	(void)xv_create(panel2, PANEL_CHOICE,
				PANEL_LABEL_STRING,"Op.", 
				PANEL_CHOICE_STRINGS,
				  "NOP","LINE","DASH","TEXT",
				  NULL,
				PANEL_NOTIFY_PROC, choice_noti_proc,
				NULL);
*/
/*****  Making of Canvas Window *********************************/
	gCanvas = (Canvas)xv_create(gFrame,CANVAS,
				XV_X, 0,
				WIN_BELOW, gTextsw,
				XV_WIDTH, kWIN_WIDTH,
				XV_HEIGHT,kWIN_HEIGHT,
				CANVAS_X_PAINT_WINDOW,TRUE,
				CANVAS_REPAINT_PROC, my_repaint_proc,
				NULL);

	gDPY = (Display *)xv_get(gFrame,XV_DISPLAY);
	gXID = (XID)xv_get(canvas_paint_window(gCanvas),XV_XID);

   /* set gGC (XCOPY drawing mode)	*/
	gGC = XCreateGC(gDPY,gXID,0,0);
	XSetForeground(gDPY,gGC,BlackPixel(gDPY,DefaultScreen(gDPY)));
	XSetBackground(gDPY,gGC,WhitePixel(gDPY,DefaultScreen(gDPY)));

   /* set gGCXOR (XOR drawing mode)	*/
	gGCXOR = XCreateGC(gDPY,gXID,0,0);
	XSetForeground(gDPY,gGCXOR,BlackPixel(gDPY,DefaultScreen(gDPY)));
	XSetBackground(gDPY,gGCXOR,WhitePixel(gDPY,DefaultScreen(gDPY)));
	XSetFunction(gDPY,gGCXOR,GXxor);
   /* set its line style a dash line	*/
   	XSetLineAttributes(gDPY,gGCXOR,1,LineOnOffDash,CapButt,JoinMiter);



/*	window_fit(panel2); */
	window_fit(gFrame);

    /* Set input mask of events in gCanvas */
    	xv_set(canvas_paint_window(gCanvas),
        		WIN_EVENT_PROC,	event_proc,
       			WIN_CONSUME_EVENTS,
			LOC_DRAG,
           		WIN_MOUSE_BUTTONS,
           		NULL,
		NULL);

    /* Main Event Loop */
	xv_main_loop(gFrame);
	return 0;
}

/********************************/
void
event_proc(window, event)
Xv_Window window;
Event    *event;
{
    static int		ssx,ssy;
    int 		endx,endy;
    static int		oldx,oldy;
    static aSymbol	*pSymbol;
    static aOffset	offset;
    static aRect	myrect;

        switch (event_action(event)) {
	    case LOC_DRAG:
		if (pSymbol) {
			draw_char_rect(pSymbol,oldx,oldy);
			oldx = event_x(event) - offset.dx;
			oldy = event_y(event) + offset.dy - myrect.height;
			draw_char_rect(pSymbol,oldx,oldy);
			}
		break;
	    case ACTION_SELECT:
            case MS_LEFT:
		if (event_is_down(event)) {
			ssx = event_x(event);
			ssy = event_y(event);
			pSymbol = whichSymPointed(ssx,ssy);
			if (pSymbol) {
				offset = get_offset(ssx,ssy,pSymbol);
				myrect = get_sym_rect(pSymbol);

			/* (oldx,oldy) is a point 
			   for drawing a rectangle enclosing the symbol */

				oldx = ssx - offset.dx;
				oldy = ssy + offset.dy - myrect.height;
		/*	draw_char_rect(pSymbol,oldx,oldy);	*/
				}
			break;
			}
		if (event_is_up(event)) {
			endx = event_x(event);
			endy = event_y(event);

		/*	If the button points a place of a label,	*/ 
		/*	change the location of the label to the up point, */
		/*	and redraw the window	*/
			if (pSymbol) {
				clear_sym_area(pSymbol);
				change_sym_loc(pSymbol,ssx,ssy,endx,endy);
			/*	clear_sym_area(pSymbol); */
				my_repaint_proc();
				}
			}
                	break;
            default:
                return;
        }
}
/********************************/
void
my_repaint_proc() /*canvas,paint_window,xrect)*/
/*Canvas	canvas;
Xv_Window paint_window;
Xv_xrectlist *xrect;*/
{
	int	i;
	int	newy;
	Xv_Font	font;
	Font	x_font;
	char	fontname[255];

	if (gNumLine > 0) {
		for (i = 0; i < gNumLine; i++) 
			plot_display(gLines[i].fx,gLines[i].fy, gLines[i].id);
		}
	if (gNumSymbol > 0) {
		for (i = 0; i<gNumSymbol; i++) {
			newy = kWIN_HEIGHT - (int)gSymbol[i].fy;
/*+*			sprintf(fontname,"Helvetica-%d\0",
				(int)gSymbol[i].fhgt);
			font = (Xv_Font)xv_find(gCanvas,FONT,
				FONT_NAME,fontname,
				NULL);
			x_font = (Font)xv_get(font,XV_XID);
			XSetFont(gDPY,gGC,x_font);
*+*/
			XDrawString(gDPY,gXID,gGC,
					(int)gSymbol[i].fx,
					newy,
					gSymbol[i].fname,
					gSymbol[i].fnum);
/*+*			xv_free(font);
			XUnloadFont(gDPY,x_font);
*+*/			
			}
		}	
}

/********************************/
void
about_proc()
{
	notice_prompt(gFrame,NULL,
		NOTICE_BUTTON_YES,"Return",
		NOTICE_NO_BEEPING,TRUE,
		NOTICE_MESSAGE_STRINGS,
		"*****  ORTEP-II  *****",
		" ",
		"ORTEP-II for SUN OPENWINDOWS.",
		" ",
		"ORTEP-II was written by ",
		"JOHNSON, C.K. (1976). Report ORNL-5138.",
		"Oak Ridge National Laboratory, Oak Ridge,",
		"Tennessee, USA.",
		" ",
		"Modified for OpenWindows by",
		"Norimasa Yamazaki,",
		"University of Electro-Communications,",
		"Tokyo, Japan",
		"e-mail : yam@crystal.pc.uec.ac.jp,",
		"16 Aug. 1991",
		" "
		"Updated for ORTEP-III",
		"(and some bugfixes)",
		"by",
		"Martin Kroeker",
		"martin@ruby.chemie.uni-freiburg.de",
		"3 Jan. 2001", 
		NULL,
		NULL);
}

/********************************/
void
open_proc()
{
	char buf[255];

	strcpy(buf,(char *)xv_get(gPanel_text,PANEL_VALUE));

#ifndef DEBUG
	if (file_exist(buf)) {
		xv_set(gTextsw,TEXTSW_FILE,buf,NULL);
	}
#endif
}

/********************************/
void
text_noti_proc(textsw,avlist)
Textsw	textsw;
Attr_avlist	avlist;
{
	char buf[255];

	buf[0] = '\0';
	textsw_append_file_name(textsw,buf);
	xv_set(gPanel_text,
		PANEL_VALUE,buf,
		NULL);	

}

/********************************/
void
draw_proc()
{
	char paneltext_name[255];
	char textsw_name[255];

	strcpy(paneltext_name,(char *)xv_get(gPanel_text,PANEL_VALUE));

	textsw_name[0] = '\0';
	textsw_append_file_name(gTextsw,textsw_name);

#ifdef DEBUGSTR
	printf("paneltext_name***%s***\n",paneltext_name);
	printf("textsw_name******%s***\n",textsw_name);
#endif
#ifndef DEBUG
	if (file_exist(paneltext_name)) {
		if (xv_get(gTextsw,TEXTSW_MODIFIED)) {
			textsw_save(gTextsw,0,0);
			}
		if (strcmp(paneltext_name,textsw_name))
			xv_set(gTextsw,TEXTSW_FILE,paneltext_name,NULL);

		XClearWindow(gDPY,gXID);
		gNumSymbol = 0;
		gNumLine  = 0;
		ortepmain_(paneltext_name); 
		my_repaint_proc();
	}
#endif
}

/********************************/
Panel_setting
text_proc(item,event)
	Panel_item	item;
	Event		*event;
{
	if(event_is_down(event) == TRUE)
	{
		switch(event_action(event))
		{
		case '\r' : 
			open_proc();
			return;
		default:
			return(PANEL_INSERT);
		}
	}
}

/********************************/
void
help_proc()
{
	notice_prompt(gFrame,NULL,
		NOTICE_BUTTON_YES,"AHA",
		NOTICE_MESSAGE_STRINGS,
"                      Ortep Command table ",
		" ",
"Function...........|.1-3.|.4-9.|...10-18..|...19-27..|...28-36..|...37-45..|..46-54.|.55-63.|.64-72.",
".Distances.........|0,1,2|.101.|.Org..ADR.|.Org..ADR.|.Tar..ADR.|.Tar..ADR.|.D.max..|.......|.......",
" Distances&Angles  |0,1,2| 102 | Org. ADR | Org. ADR | Tar. ADR | Tar. ADR | D max. |       |       ",
" Principal Axes    |     | 103 |          |          |          |          |        |       |       ",
" Distances                                                                                          ",
" -single convolute |0,1,2| 105 | Org. NR  | Org. NR  | Tar. NR  | Tar. NR  | D max. |NR type|       ",   
" -reiterate conv.  |0,1,2| 106 | Org. NR  | Org. NR  | Tar. NR  | Tar. NR  | D max. |NR type|       ",   
" Plotter Control                                                                                    ",
" Initialize        |     | 201 |          |          |          |          |        |       |       ",
" Shift origin/term.|     | 202 |    X     |    Y     |          |          |        |       |       ",
" Color             |     | 204 | ICOLOR   |          |          |          |        |       |       ",
" Pen width         |     | 205 | WIDTH    |          |          |          |        |       |       ",
" Drawing Parameters                                                                                 ",
" Dimensions&View   |     | 301 |    X     |    Y     |   VIEW   |  BORDER  |        |       |       ",
" Title rotation    |     | 302 |  THETA   |          |          |          |        |       |       ",
" Retrace displace  |     | 303 |  DISP    |          |          |          |        |       |       ",
" Ellipse smoothness|     | 304 |  CHORD   |          |          |          |        |       |       ",
" Atoms array                                                                                        ",
		NULL,
		NULL);
}

/********************************/
void
quit_proc()
{
	char	message[255];
	char	tmp_file[255];
	int	stat;
	FILE	*fp;

	sprintf(tmp_file,"/tmp/ortep%d\0",getpid());	
	if (fp = fopen(tmp_file,"r")) {
		fclose(fp);
		/* delete the tmp file	*/
		strcpy(message, "/bin/rm ");
		strcat(message, tmp_file);
		stat = system(message);
	}
	xv_destroy_safe(gFrame);
}

/********************************/
void
ps_save_proc()
{
char	filename[255];


	if (gNumLine == 0) return; 
	
	/* get current file name, and append '.ps' extension.	*/
	sprintf(filename,"%s.ps\0",(char *)xv_get(gPanel_text,
					PANEL_VALUE));
	/* now we write a postscript file on disk	*/
	save_ps_file(filename);
}

/********************************/
void save_ps_file(filename)
char	filename[255];
{
	int	i;
	int	xtran=0;
	int	ytran=36;
	float	scale = 1.0;
	FILE	*fp;		/* output postscript file*/
	time_t	clock;
	struct	tm	*now;

	clock = time((time_t *)0);
	now = localtime(&clock);

	if ((fp = fopen(filename,"w")) != NULL) {
	
	/******* write the prologue ******************/
	fprintf(fp,"%%!PS-Adobe-2.0 EPSF-2.0\n");
	fprintf(fp,"%%%%BoundingBox:0 0 600 600\n");
	fprintf(fp,"%%%%Title: %s\n",filename);
	fprintf(fp,"%%%%Creator: %s with ORTEP\n",getlogin());
	fprintf(fp,"%%%%CreationDate: %s",asctime(now) );
	fprintf(fp,"%%%%DocumentFonts:Helvetica\n");
	fprintf(fp,"%%%%EndComments\n");
	fprintf(fp,"%d   %d  translate\n",xtran,ytran);
	fprintf(fp,"%.2f dup scale\n",scale);
	fprintf(fp,"%.2f setlinewidth\n",gPensize);
	fprintf(fp,"/m /moveto load def\n");
	fprintf(fp,"/l /lineto load def\n\n");
	/****** Write line data ******/
	for (i = 0; i<gNumLine ; i++) 
		if (gLines[i].id == 2)
			fprintf(fp,"%.3f %.3f l\n",gLines[i].fx,gLines[i].fy);
		else {
			fprintf(fp,"stroke\n");
			fprintf(fp,"%.3f %.3f m\n",gLines[i].fx,gLines[i].fy);
		     }
	fprintf(fp,"stroke\n\n");
	/***** Write symbol data *****/
	if (gNumSymbol>0) {
		for (i = 0;i < gNumSymbol;i++) {
			fprintf(fp,"gsave\n");
			fprintf(fp,
				"/Helvetica findfont %d scalefont setfont\n",
				(int)gSymbol[i].fhgt);
			fprintf(fp,"%.0f %.0f m\n",
					gSymbol[i].fx,gSymbol[i].fy);
			if (gSymbol[i].ftheta > 1.0) 
				fprintf(fp,"%f rotate\n",gSymbol[i].ftheta);
			fprintf(fp,"(%.*s)\n",gSymbol[i].fnum,
						gSymbol[i].fname);
			fprintf(fp,"show\ngrestore\n");
		}
	}
	/***** Write the epilogue ******/
	fprintf(fp,"showpage\n");
	fclose(fp);
	} /* if ((fp = fopen...	*/			

}
/********************************/
void
print_proc()
{
	int	result;
	char	message[255];
	char	tmp_file[255];
	int	stat;
	
	if (gNumLine == 0) return; 
	
	result = notice_prompt(gFrame,NULL,
		NOTICE_MESSAGE_STRINGS,
		"Do you really want to print?",
		NULL,
		NOTICE_BUTTON_YES,"Print",
		NOTICE_BUTTON_NO,"Cancel",
		NULL);

	if (result == NOTICE_YES) {
		/* make a temporal file for ps file	*/
		sprintf(tmp_file,"/tmp/ortep%d\0",getpid());	
		save_ps_file(tmp_file);
	
		/* print this file using 'lpr'		*/
		strcpy(message, "lpr ");
		strcat(message, tmp_file);
		stat = system(message);
	
		/* this temporal file is to be deleted in quit_proc()	*/

	} /* if (result == ...	*/
}

/********************************************************/
/* This plot_ routine is called by ORTEP MAIN PROGRAM.	*/
/* But this routine does'nt really draw a line.		*/ 
/* It only stores the line data in the variable gLines.	*/ 
void plot_(x,y,id) 
float	*x,*y; 
int	*id;
{

	if (gNumLine >= kMAX_LINES) {
		notice_prompt(gFrame,NULL,
			NOTICE_BUTTON_YES,"Ok",
			NOTICE_MESSAGE_STRINGS,
			"Number of primitive lines ",
			"exceed the limit (64000).   ",
			"I can not go on!!",
			NULL,
			NULL);
		xv_destroy_safe(gFrame);
		exit(1);
	}
	gLines[gNumLine].fx = *x + gXorigin;
	gLines[gNumLine].fy = *y + gYorigin;
	gLines[gNumLine].id = *id;
	gNumLine++;

	if (*id < 0) {
		gXorigin += *x;
		gYorigin += *y;
		}
}

/********************************************************/
/* It is this plot_display routine that really plots lines on Display */
void
plot_display(x,y,id)
float	x,y;
int	id;
{
	static	int	sx,sy;
	int		newy;

	newy = kWIN_HEIGHT - (int)y;
	if (id == 2)
		XDrawLine(gDPY,gXID,gGC,sx,sy,(int)x,newy);
	sx = (int)x;
	sy = newy;
}

/********************************/
int
file_exist(fname)
char *fname;
{
	FILE	*fp;
	if (fp = fopen(fname,"r")) {
		fclose(fp);
		return 1;
		}
	else
		{
		notice_prompt(gFrame,NULL,
			NOTICE_BUTTON_YES,"Ok",
			NOTICE_MESSAGE_STRINGS,
			"Can not open the file: ",
			"   ",fname,
			NULL,
			NULL);
		return 0;
		}

}

/****************************************************************/
/* Like plot_ routine, this routine does'nt plot a symbol on	*/
/* the screen, it only stores symbol data in the global var.	*/
void
symbol_(x,y,hgt,ch,th,num)
float	*x,*y;
float	*hgt;
char	*ch;
float	*th;
int	*num;
{
	if (gNumSymbol >= kMAX_SYMBOLS) {
		notice_prompt(gFrame,NULL,
			NOTICE_BUTTON_YES,"Ok",
			NOTICE_MESSAGE_STRINGS,
			"Number of primitive symbols ",
			"exceed the limit 2000.   ",
			"I can not go on!!",
			NULL,
			NULL);
		xv_destroy_safe(gFrame);
		exit(1);
		}
	gSymbol[gNumSymbol].fx = *x + gXorigin;
	gSymbol[gNumSymbol].fy = *y + gYorigin;
	gSymbol[gNumSymbol].fhgt = *hgt;
	sprintf(gSymbol[gNumSymbol].fname,"%.*s\0",*num,ch);
	gSymbol[gNumSymbol].ftheta = *th;
	gSymbol[gNumSymbol].fnum = *num;
	gNumSymbol++;
}
/****************************************************************/
/* Like plot_ routine, this routine does'nt plot a symbol on	*/
/* the screen, it only stores symbol data in the global var.	*/
void
number_(x,y,hgt,val,th,num)
float *x,*y;
float *hgt;
float *val;
float *th;
int   *num;
{
	char	value[72];

	/*  offset for x,y. 260 and 320 are magic numbers */
	*x +=260;
	*y +=320;

	sprintf(value,"%.*f\0",*num,*val);

	gSymbol[gNumSymbol].fx = *x + gXorigin;
	gSymbol[gNumSymbol].fy = *y + gYorigin;
	gSymbol[gNumSymbol].fhgt = *hgt;
	sprintf(gSymbol[gNumSymbol].fname,"%s",value);
	gSymbol[gNumSymbol].ftheta = *th;
	gSymbol[gNumSymbol].fnum = strlen(value);
	gNumSymbol++;		

}

/****** these are dummy routines ************/
void gpsltm_()
{
}
void ginit_()
{
}
void vsini_()
{
}
void device_()
{}
void rwind_()
{}
void charac_()
{}
void newpen_()
{}
void vsterm_()
{
}
void tinput_()
{}
void pinit_()
{}
void drawtitle_()
{
}

/********************************/
void setpensize_(aPensize)
float	*aPensize;
{
	/* Change pen width	*/
	/* this routine is called by 303 card of ORTEP	*/
	if (*aPensize > 0 && *aPensize < 4)
		gPensize = *aPensize;
	else
		gPensize = 0.5;
}

/********************************/
/* Cange the position of thisSymbol from Org point to New point.*/
void
change_sym_loc(thisSymbol,from_x,from_y,to_x,to_y)
aSymbol	*thisSymbol;
int	from_x,from_y;
int	to_x,to_y;
{
	int	dx,dy;
		
	dx = to_x - from_x;
	dy = to_y - from_y;
	(thisSymbol->fx) += (float)dx;
	(thisSymbol->fy) -= (float)dy;
}

/********************************/
aOffset
get_offset(x,y,thisSymbol)
int	x,y;
aSymbol	*thisSymbol;
{
	aOffset	offset;
	
	offset.dx = x - thisSymbol->fx;
	offset.dy = (kWIN_HEIGHT - y) - thisSymbol->fy;
	return offset;
}

/****************************************************************/
/* Draw an outbound rectangle which surrounds the Symbol	*/
/* 								*/
/*    Changed    ---Nov. 1, 1991---				*/
/*	Draw the Symbol itself while dragging mouse.		*/
/*	Do not draw a rectangle now.				*/
void 
draw_char_rect(thisSymbol,x,y)
aSymbol	*thisSymbol;
int	x,y;
{
	int		originx,originy;	
	int		diffx,diffy;
/*	aRect		myrect; MK*/
	Xv_Font	font;
	Font	x_font;
	char	fontname[255];
	
/*	myrect = get_sym_rect(thisSymbol);*/

	/* Using XOR mode for drawing so as not to affect	*/
	/* the other lines under this rectangle.		*/
/*	XDrawRectangle(gDPY,gXID,gGCXOR,
			x - 1,y - 1,
			myrect.width + 2 ,myrect.height + 2);*/

	/*  Draw the Symbol while dragging	*/
	
/*+*	sprintf(fontname,"Helvetica-%d\0",
				(int)thisSymbol->fhgt);
	font = (Xv_Font)xv_find(gCanvas,FONT,
				FONT_NAME,fontname,
				NULL);
	x_font = (Font)xv_get(font,XV_XID);
	XSetFont(gDPY,gGCXOR,x_font);
*+*/
	XDrawString(gDPY,gXID,gGCXOR,
					x - 1,
/*					y + myrect.height + 1,*/
					y + 10 + 1,
					thisSymbol->fname,
					thisSymbol->fnum);

/*+*	xv_free(font); 
			XUnloadFont(gDPY,x_font);
*+*/
}

/********************************/
aSymbol
*whichSymPointed(x,y)
int	x,y;
{
	int	i;
	aRect	myrect;
		
	for (i = 0;i<gNumSymbol;i++) {
		myrect = get_sym_rect(&gSymbol[i]);
		if (gSymbol[i].fx < x &&
			x < (gSymbol[i].fx + myrect.width) &&
			(kWIN_HEIGHT - gSymbol[i].fy) > y &&
			y>(kWIN_HEIGHT - gSymbol[i].fy - myrect.height))
			{
	/* when (x,y) is included in a symbol rectangle,
	   return the pointer of the symbol structure	*/ 
			return &gSymbol[i];
			}
		}
	/* if no symbol pointed, return null	*/
	return NULL;
}

/********************************/
aRect
get_sym_rect(thisSymbol)
aSymbol	*thisSymbol;
{
	Xv_Font		font;
	XFontStruct	*fs;
	XCharStruct	cs;
	int		dir,ascent,descent;
	char		fontname[255];
	aRect		myrect;	
/*+*
	sprintf(fontname,"Helvetica-%d\0",(int)(thisSymbol->fhgt));
	font = (Xv_Font)xv_find(gCanvas,
				FONT,FONT_NAME,fontname,
				NULL);
	fs   = (XFontStruct *)xv_get(font,FONT_INFO);
	XTextExtents(fs,thisSymbol->fname,
			thisSymbol->fnum,
			&dir,&ascent,&descent,&cs);
	myrect.width = cs.rbearing - cs.lbearing;
	myrect.height= cs.ascent + cs.descent;
	xv_free(font);
	XFreeFont(gDPY,fs);
*+*/
	myrect.width=10.*thisSymbol->fnum;
	myrect.height=10.;
	return myrect;
}

/********************************/
/* clear the area where the symbol was */
void
clear_sym_area(thisSymbol)
aSymbol	*thisSymbol;
{
	int	x0,y0;
	aOffset	offset;
	aRect	myrect;
	
	myrect = get_sym_rect(thisSymbol);
	x0 = (int)thisSymbol->fx;
	y0 = kWIN_HEIGHT - (int)thisSymbol->fy - myrect.height;
	XClearArea(gDPY,gXID,
		x0  ,
		y0  ,
		myrect.width ,
		myrect.height ,
		TRUE);
}

/********************************/
/*
void
choice_noti_proc(item,value,event)
Panel_item	item;
int		value;
Event		*event;
{
	gCanvas_choice = value;
}
*/
/*	the end of this sorce file	*/

void initsc_()
{}
void endsc_()
{}
void colrsc_()
{}
void penwsc_()
{}
void pensc_()
{}
